/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author petr
 */

import java.util.ArrayList;
import java.util.List;

public class VelkeCislo {
    
    private List<Integer> cislo;

    private VelkeCislo() {
        cislo = new ArrayList<Integer>();
    }

    public VelkeCislo(long c) {
        this();
        c = Math.abs(c);
        do {          
           cislo.add((int)(c % 10));
           c /= 10;
        } while(c != 0);
    }
    
    public VelkeCislo secti(VelkeCislo cislo2) {
        VelkeCislo vc = new VelkeCislo();

        int sum = 0;
        int len = Math.max(this.cislo.size(),cislo2.cislo.size());

        for(int i = 0; i < len; i++) {
            if(i < this.cislo.size())
                sum += this.cislo.get(i);
            if(i < cislo2.cislo.size())
                sum += cislo2.cislo.get(i);
            vc.cislo.add(sum % 10);
            sum /= 10;
        }
        if(sum != 0)
            vc.cislo.add(sum);

        return vc;
    }

    public VelkeCislo nasob(VelkeCislo cislo2) {
        VelkeCislo vc = new VelkeCislo(0);
        
        for(int i = 0; i < cislo2.cislo.size();i++) {
            for(int j = 0; j < this.cislo.size(); j++) {
                int sum = cislo2.cislo.get(i) * this.cislo.get(j);
                
                VelkeCislo tmp = new VelkeCislo(sum);
                tmp.multiple10(i+j);
                vc = vc.secti(tmp);
            }
        }
        
        return vc;
    }

    private void multiple10(int e) {
        if(cislo.size() == 1 && cislo.get(0) == 0)
            return;

        e = Math.abs(e);
        List<Integer> tmp = new ArrayList<Integer>();
        for (int i = 0; i < e; i++) {
            tmp.add(0);
        }

        tmp.addAll(cislo);
        cislo = tmp;
    }

    @Override
    public String toString() {
        StringBuffer str = new StringBuffer();
        int mez = cislo.size() % 3;
        for(int i = cislo.size()-1; i >= 0; i--) {
            str.append(cislo.get(i));
            if(--mez == 0 && i != 0) str.append(" ");
            if(mez <= 0) mez = 3;
        }
        return str.toString();
    }
}
